%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate Lookup Table Values                                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Written By: John Gehrig <jdg.gehrig@gmail.com>
function y = calc_lookup_table(x_soc, x_cur)
    % function y = calc_lookup_table(x_soc, x_cur)
    % Describe me here...
    % 
    % Example:
    % 
    % [EXAMPLE HERE]
    %
    global batt_soc;
    global batt_volt;
    
    % ensure the values of x inputs are sorted
    x_soc = sort(x_soc);
    x_cur = sort(x_cur);
    
    % initialize y matrix size
    % I feel the need, the need for speed
    len_soc = length(x_soc);
    len_cur = length(x_cur);
    y(1:len_soc, 1:len_cur) = 0;
    
    col = length(x_cur);
    for current = x_cur
        % run the simulink model
        % variables soc & volt are generated by the simulink model
        % as outputs containing state of charge and pack voltage
        % respectively. Values are stored as an array.
        sim('batt_discharge');
        X
        
        % FIXME
        bins = [0:2:100];
        
        assignin('base', 'model_current', current);
        
        % perform statistical binning
        %y(row,:) = bindata(volt, soc, bins)
        % not sure, but this has to be run twice?
        y(:,col) = bindata(batt_volt, batt_soc, bins);
        y(:,col) = bindata(batt_volt, batt_soc, bins);
        col = col - 1;
    end