/*
 * File: LFEV.c
 *
 * Code generated for Simulink model 'LFEV'.
 *
 * Model version                  : 1.80
 * Simulink Coder version         : 8.8 (R2015a) 09-Feb-2015
 * C/C++ source code generated on : Mon Nov  9 23:37:50 2015
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "LFEV.h"
#include "LFEV_private.h"

/* Block signals (auto storage) */
B_LFEV_T LFEV_B;

/* Block states (auto storage) */
DW_LFEV_T LFEV_DW;

/* External inputs (root inport signals with auto storage) */
ExtU_LFEV_T LFEV_U;

/* External outputs (root outports fed by signals with auto storage) */
ExtY_LFEV_T LFEV_Y;

/* Real-time model */
RT_MODEL_LFEV_T LFEV_M_;
RT_MODEL_LFEV_T *const LFEV_M = &LFEV_M_;
real_T look2_binlxpw(real_T u0, real_T u1, const real_T bp0[], const real_T bp1[],
                     const real_T table[], const uint32_T maxIndex[], uint32_T
                     stride)
{
  real_T frac;
  uint32_T bpIndices[2];
  real_T fractions[2];
  real_T yL_1d;
  uint32_T iRght;
  uint32_T bpIdx;
  uint32_T iLeft;

  /* Lookup 2-D
     Search method: 'binary'
     Use previous index: 'off'
     Interpolation method: 'Linear'
     Extrapolation method: 'Linear'
     Use last breakpoint for index at or above upper limit: 'off'
     Remove protection against out-of-range input in generated code: 'off'
   */
  /* Prelookup - Index and Fraction
     Index Search method: 'binary'
     Extrapolation method: 'Linear'
     Use previous index: 'off'
     Use last breakpoint for index at or above upper limit: 'off'
     Remove protection against out-of-range input in generated code: 'off'
   */
  if (u0 <= bp0[0U]) {
    iLeft = 0U;
    frac = (u0 - bp0[0U]) / (bp0[1U] - bp0[0U]);
  } else if (u0 < bp0[maxIndex[0U]]) {
    /* Binary Search */
    bpIdx = maxIndex[0U] >> 1U;
    iLeft = 0U;
    iRght = maxIndex[0U];
    while (iRght - iLeft > 1U) {
      if (u0 < bp0[bpIdx]) {
        iRght = bpIdx;
      } else {
        iLeft = bpIdx;
      }

      bpIdx = (iRght + iLeft) >> 1U;
    }

    frac = (u0 - bp0[iLeft]) / (bp0[iLeft + 1U] - bp0[iLeft]);
  } else {
    iLeft = maxIndex[0U] - 1U;
    frac = (u0 - bp0[maxIndex[0U] - 1U]) / (bp0[maxIndex[0U]] - bp0[maxIndex[0U]
      - 1U]);
  }

  fractions[0U] = frac;
  bpIndices[0U] = iLeft;

  /* Prelookup - Index and Fraction
     Index Search method: 'binary'
     Extrapolation method: 'Linear'
     Use previous index: 'off'
     Use last breakpoint for index at or above upper limit: 'off'
     Remove protection against out-of-range input in generated code: 'off'
   */
  if (u1 <= bp1[0U]) {
    iLeft = 0U;
    frac = (u1 - bp1[0U]) / (bp1[1U] - bp1[0U]);
  } else if (u1 < bp1[maxIndex[1U]]) {
    /* Binary Search */
    bpIdx = maxIndex[1U] >> 1U;
    iLeft = 0U;
    iRght = maxIndex[1U];
    while (iRght - iLeft > 1U) {
      if (u1 < bp1[bpIdx]) {
        iRght = bpIdx;
      } else {
        iLeft = bpIdx;
      }

      bpIdx = (iRght + iLeft) >> 1U;
    }

    frac = (u1 - bp1[iLeft]) / (bp1[iLeft + 1U] - bp1[iLeft]);
  } else {
    iLeft = maxIndex[1U] - 1U;
    frac = (u1 - bp1[maxIndex[1U] - 1U]) / (bp1[maxIndex[1U]] - bp1[maxIndex[1U]
      - 1U]);
  }

  /* Interpolation 2-D
     Interpolation method: 'Linear'
     Use last breakpoint for index at or above upper limit: 'off'
     Overflow mode: 'portable wrapping'
   */
  bpIdx = iLeft * stride + bpIndices[0U];
  yL_1d = (table[bpIdx + 1U] - table[bpIdx]) * fractions[0U] + table[bpIdx];
  bpIdx += stride;
  return (((table[bpIdx + 1U] - table[bpIdx]) * fractions[0U] + table[bpIdx]) -
          yL_1d) * frac + yL_1d;
}

/* Model step function */
void LFEV_step(void)
{
  real_T rtb_est_soc;

  /* Outputs for Atomic SubSystem: '<Root>/LFEV Battery Pack Integral SOC Controller' */
  /* DiscreteIntegrator: '<S1>/coulomb_counter' incorporates:
   *  Constant: '<S1>/initial_soc'
   *  Constant: '<S1>/reset'
   */
  if ((LFEV_P.reset_Value > 0.0) && (LFEV_DW.coulomb_counter_PrevResetState <= 0))
  {
    LFEV_DW.coulomb_counter_DSTATE = LFEV_P.initial_soc_Value;
  }

  /* Sum: '<S1>/Sum2' incorporates:
   *  DiscreteIntegrator: '<S1>/coulomb_counter'
   *  DiscreteIntegrator: '<S4>/Integrator'
   */
  rtb_est_soc = LFEV_DW.coulomb_counter_DSTATE + LFEV_DW.Integrator_DSTATE;

  /* Outputs for Atomic SubSystem: '<S1>/battery_model' */

  /* Inport: '<Root>/current' */
  LFEV_battery_model(LFEV_U.NoisyModelCurrent, rtb_est_soc,
                     &LFEV_B.battery_model, (P_battery_model_LFEV_T *)
                     &LFEV_P.battery_model);

  /* End of Outputs for SubSystem: '<S1>/battery_model' */

  /* Update for DiscreteIntegrator: '<S1>/coulomb_counter' incorporates:
   *  Constant: '<S1>/reset'
   *  Gain: '<S1>/invert'
   *  Inport: '<Root>/current'
   */
  LFEV_DW.coulomb_counter_DSTATE += LFEV_P.invert_Gain *
    LFEV_U.NoisyModelCurrent * LFEV_P.coulomb_counter_gainval;
  if (LFEV_P.reset_Value > 0.0) {
    LFEV_DW.coulomb_counter_PrevResetState = 1;
  } else if (LFEV_P.reset_Value < 0.0) {
    LFEV_DW.coulomb_counter_PrevResetState = -1;
  } else if (LFEV_P.reset_Value == 0.0) {
    LFEV_DW.coulomb_counter_PrevResetState = 0;
  } else {
    LFEV_DW.coulomb_counter_PrevResetState = 2;
  }

  /* End of Update for DiscreteIntegrator: '<S1>/coulomb_counter' */

  /* Update for DiscreteIntegrator: '<S4>/Integrator' incorporates:
   *  Constant: '<S1>/integral_gain'
   *  Inport: '<Root>/voltage'
   *  Product: '<S4>/IOut'
   *  Sum: '<S1>/Sum3'
   */
  LFEV_DW.Integrator_DSTATE += (LFEV_U.NoisyModelVoltage -
    LFEV_B.battery_model.Voltage) * LFEV_P.integral_gain_Value *
    LFEV_P.Integrator_gainval;

  /* Saturate: '<S1>/saturation' */
  if (rtb_est_soc > LFEV_P.saturation_UpperSat) {
    /* Outport: '<Root>/soc' */
    LFEV_Y.soc = LFEV_P.saturation_UpperSat;
  } else if (rtb_est_soc < LFEV_P.saturation_LowerSat) {
    /* Outport: '<Root>/soc' */
    LFEV_Y.soc = LFEV_P.saturation_LowerSat;
  } else {
    /* Outport: '<Root>/soc' */
    LFEV_Y.soc = rtb_est_soc;
  }

  /* End of Saturate: '<S1>/saturation' */
  /* End of Outputs for SubSystem: '<Root>/LFEV Battery Pack Integral SOC Controller' */
}

/* Model initialize function */
void LFEV_initialize(void)
{
  /* Registration code */

  /* initialize error status */
  rtmSetErrorStatus(LFEV_M, (NULL));

  /* block I/O */
  (void) memset(((void *) &LFEV_B), 0,
                sizeof(B_LFEV_T));

  /* states (dwork) */
  (void) memset((void *)&LFEV_DW, 0,
                sizeof(DW_LFEV_T));

  /* external inputs */
  (void) memset((void *)&LFEV_U, 0,
                sizeof(ExtU_LFEV_T));

  /* external outputs */
  LFEV_Y.soc = 0.0;

  /* InitializeConditions for Atomic SubSystem: '<Root>/LFEV Battery Pack Integral SOC Controller' */
  /* Start for Atomic SubSystem: '<Root>/LFEV Battery Pack Integral SOC Controller' */
  /* InitializeConditions for DiscreteIntegrator: '<S1>/coulomb_counter' incorporates:
   *  Start for Constant: '<S1>/initial_soc'
   */
  LFEV_DW.coulomb_counter_DSTATE = LFEV_P.initial_soc_Value;

  /* End of Start for SubSystem: '<Root>/LFEV Battery Pack Integral SOC Controller' */
  LFEV_DW.coulomb_counter_PrevResetState = 2;

  /* InitializeConditions for DiscreteIntegrator: '<S4>/Integrator' */
  LFEV_DW.Integrator_DSTATE = LFEV_P.Integrator_IC;

  /* End of InitializeConditions for SubSystem: '<Root>/LFEV Battery Pack Integral SOC Controller' */
}

/* Model terminate function */
void LFEV_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
