/*
 * File: LFEV.h
 *
 * Code generated for Simulink model 'LFEV'.
 *
 * Model version                  : 1.80
 * Simulink Coder version         : 8.8 (R2015a) 09-Feb-2015
 * C/C++ source code generated on : Mon Nov  9 23:37:50 2015
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_LFEV_h_
#define RTW_HEADER_LFEV_h_
#include <stddef.h>
#include <string.h>
#ifndef LFEV_COMMON_INCLUDES_
# define LFEV_COMMON_INCLUDES_
#include "rtwtypes.h"
#endif                                 /* LFEV_COMMON_INCLUDES_ */

#include "LFEV_types.h"

/* Child system includes */
#include "LFEV_battery_model.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

/* Block signals (auto storage) */
typedef struct {
  B_battery_model_LFEV_T battery_model;/* '<S1>/battery_model' */
} B_LFEV_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T coulomb_counter_DSTATE;       /* '<S1>/coulomb_counter' */
  real_T Integrator_DSTATE;            /* '<S4>/Integrator' */
  int8_T coulomb_counter_PrevResetState;/* '<S1>/coulomb_counter' */
} DW_LFEV_T;

/* External inputs (root inport signals with auto storage) */
typedef struct {
  real_T NoisyModelCurrent;            /* '<Root>/current' */
  real_T NoisyModelVoltage;            /* '<Root>/voltage' */
} ExtU_LFEV_T;

/* External outputs (root outports fed by signals with auto storage) */
typedef struct {
  real_T soc;                          /* '<Root>/soc' */
} ExtY_LFEV_T;

/* Parameters (auto storage) */
struct P_LFEV_T_ {
  real_T CURRENT[11];                  /* Variable: CURRENT
                                        * Referenced by: '<S3>/LiFePO4 Battery Pack Experimental Model'
                                        */
  real_T SOC[50];                      /* Variable: SOC
                                        * Referenced by: '<S3>/LiFePO4 Battery Pack Experimental Model'
                                        */
  real_T VOLTAGE[550];                 /* Variable: VOLTAGE
                                        * Referenced by: '<S3>/LiFePO4 Battery Pack Experimental Model'
                                        */
  real_T reset_Value;                  /* Expression: 0
                                        * Referenced by: '<S1>/reset'
                                        */
  real_T initial_soc_Value;            /* Expression: 50
                                        * Referenced by: '<S1>/initial_soc'
                                        */
  real_T coulomb_counter_gainval;      /* Computed Parameter: coulomb_counter_gainval
                                        * Referenced by: '<S1>/coulomb_counter'
                                        */
  real_T Integrator_gainval;           /* Computed Parameter: Integrator_gainval
                                        * Referenced by: '<S4>/Integrator'
                                        */
  real_T Integrator_IC;                /* Expression: InitialConditionForIntegrator
                                        * Referenced by: '<S4>/Integrator'
                                        */
  real_T integral_gain_Value;          /* Expression: .05
                                        * Referenced by: '<S1>/integral_gain'
                                        */
  real_T invert_Gain;                  /* Expression: -1
                                        * Referenced by: '<S1>/invert'
                                        */
  real_T saturation_UpperSat;          /* Expression: 100
                                        * Referenced by: '<S1>/saturation'
                                        */
  real_T saturation_LowerSat;          /* Expression: 0
                                        * Referenced by: '<S1>/saturation'
                                        */
  P_battery_model_LFEV_T battery_model;/* '<S1>/battery_model' */
};

/* Real-time Model Data Structure */
struct tag_RTM_LFEV_T {
  const char_T * volatile errorStatus;
};

/* Block parameters (auto storage) */
extern P_LFEV_T LFEV_P;

/* Block signals (auto storage) */
extern B_LFEV_T LFEV_B;

/* Block states (auto storage) */
extern DW_LFEV_T LFEV_DW;

/* External inputs (root inport signals with auto storage) */
extern ExtU_LFEV_T LFEV_U;

/* External outputs (root outports fed by signals with auto storage) */
extern ExtY_LFEV_T LFEV_Y;

/* Model entry point functions */
extern void LFEV_initialize(void);
extern void LFEV_step(void);
extern void LFEV_terminate(void);

/* Real-time Model object */
extern RT_MODEL_LFEV_T *const LFEV_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Note that this particular code originates from a subsystem build,
 * and has its own system numbers different from the parent model.
 * Refer to the system hierarchy for this subsystem below, and use the
 * MATLAB hilite_system command to trace the generated code back
 * to the parent model.  For example,
 *
 * hilite_system('battery_model/LFEV Battery Pack Integral SOC Controller')    - opens subsystem battery_model/LFEV Battery Pack Integral SOC Controller
 * hilite_system('battery_model/LFEV Battery Pack Integral SOC Controller/Kp') - opens and selects block Kp
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'battery_model'
 * '<S1>'   : 'battery_model/LFEV Battery Pack Integral SOC Controller'
 * '<S2>'   : 'battery_model/LFEV Battery Pack Integral SOC Controller/Battery Model (Open Circuit)'
 * '<S3>'   : 'battery_model/LFEV Battery Pack Integral SOC Controller/battery_model'
 * '<S4>'   : 'battery_model/LFEV Battery Pack Integral SOC Controller/integral_controller'
 */
#endif                                 /* RTW_HEADER_LFEV_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
