%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                       Calculate Lookup Table Values                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Lafayette College
% Electrical and Computer Engineering
%
% Battery Pack Model Calculations
% Written By: John Gehrig <jdg.gehrig@gmail.com>

function y = calc_lookup_table(x_soc, x_cur)
	% function y = calc_lookup_table(x_soc, x_cur)
	% Describe me here...
	% 
	% Example:
	% 
	% [EXAMPLE HERE]
	%
	%global batt_soc;
	%global batt_volt;
	
	% ensure the values of x inputs are sorted
	x_soc = sort(x_soc);
	x_cur = sort(x_cur);
	
	% initialize y matrix size
	% I feel the need, the need for speed
	len_soc = length(x_soc);
	len_cur = length(x_cur);
	y(1:len_soc, 1:len_cur) = 0;
	
	col = 1;
	for current = x_cur
		% run the simulink model
		% variables soc & volt are generated by the simulink model
		% as outputs containing state of charge and pack voltage
		% respectively. Values are stored as an array.
		
		% set model current
		assignin('base', 'model_current', current);
		
		% run proper model based on charge/discharge
		% of the battery
		if current > 0
			fprintf('DISCHARGE: %i\n', current);
			sim('batt_discharge');
		elseif current < 0
			fprintf('CHARGE: %i\n', -current);
			sim('batt_charge');
		else
			sim('batt_open');
		end
		
		% FIXME automate this calculation
		% only works for input [1:2:100]
		bins = [0:2:100];
		
		% perform statistical binning
		%y(:,col) = bindata(volt, soc, bins)
		result = bindata(volt, soc, bins);
		y(:,col) = result;
		
		
		col = col + 1;
	end
